const fs = require('fs');
const axios = require('axios').default;
const zipdir = require('zip-dir');
const callService = require('../../tools/callService');

class ProjectManager {

  /**
   * 
   * @param {Object} params
   * @param {Object} [params.projectId] - Project id
   * @param {Boolean} [params.testEnv] - Use project test env
   */
  constructor (params) {
    this._projectId = params.projectId;
    this._testEnv = !!params.testEnv;
  }

  /**
   * @returns {Promise}
   * @param {Object} params
   * @param {String} params.serviceKey
   * @param {Object} [params.params]
   * @param {Object} [params.cookies]
   * @param {Object} [params.options]
   * @param {Boolean} [params.options.skipCache]
   */
  async callService (params) {
    params.options = params.options || {}
    let output = await callService({
      projectId: this._projectId,
      serviceKey: params.serviceKey,
      params: params.params,
      options: {
        testEnv: this._testEnv,
        skipCache: !!params.options.skipCache
      }
    })
    return output;
  }
}

module.exports = ProjectManager;