const callService = require('../../tools/callService');

const callICService = (serviceKey, serviceParams) => {
  return callService({
    projectId: '702926627029266270292662',
    serviceKey: serviceKey,
    params: serviceParams || {}
  })
}

class ProjectsManager {

  /**
   * 
   * @param {Object} params
   * @param {Object} [params.accessToken] - Personal Access Token
   */
  constructor (params = {}) {
    this._accessToken = params.accessToken || process.env.IC_ACCESS_TOKEN;
  }

  /**
   * @returns {Promise<{project:{ _id: String, name: String }, role: String }[]>} User projects data
   */
  async listProjects () {
    let output = await callICService('getCurrentPersonProjects', {
      accessToken: this._accessToken
    })
    return output;
  }

}

module.exports = ProjectsManager;