const request = require('request');

module.exports = ({ projectId, serviceKey, params, options }) => {
  params = params || {};
  options = options || {};
  return new Promise((resolve, reject) => {
    request(`https://${(options.testEnv?'t':(options.skipCache?'s':''))+projectId}.projects.ideascloud.io/services/${serviceKey}/execute`, {
      method: 'POST',
      headers: {
        'Content-Type': 'application/json'
      },
      body: JSON.stringify(params)
    }, (err, resp) => {
      if (err) {
        reject(err);
        return;
      }
      let body = resp.body;
      try {
        body = JSON.parse(resp.body);
      } catch (err) {}
      if (Math.floor(resp.statusCode/100) != 2) {
        reject({
          statusCode: resp.statusCode,
          statusMessage: resp.statusMessage,
          body: body

        });
        return;
      }
      resolve(body);
    })
  })
}
